package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLCell_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLCell extends JNIObject  {
	
	/* @generated */
	protected ISLCell(long ptr) {
		/*** PROTECTED REGION ID(ISLCell_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLCell build(long ptr) {
		return new ISLCell(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLCell_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_cell_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_cell_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_cell_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_cell_get_domain 
	 * 
	 * @generated
	**/
	public ISLBasicSet getDomain() {
		/*** PROTECTED REGION ID(isl_cell_get_domain) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLBasicSet.build(ISLNative.isl_cell_get_domain(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_cell_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_cell_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_cell_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_cell_numberof_vertex 
	 * 
	 * @generated
	**/
	public int getNbVertices() {
		/*** PROTECTED REGION ID(isl_cell_numberof_vertex) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_cell_numberof_vertex(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_cell_get_vertex_at 
	 * 
	 * @generated
	**/
	public ISLVertex getVertexAt(int pos) {
		/*** PROTECTED REGION ID(isl_cell_get_vertex_at) DISABLED START ***/
		ISLVertex res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLVertex.build(ISLNative.isl_cell_get_vertex_at(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLCell_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
